<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
                xmlns:dc="http://purl.org/dc/elements/1.0/"                                 xmlns:dcq="http://purl.org/dc/qualifiers/1.0/"                                 xmlns:dct="http://dublincore.org/2000/03/13-dctype"                                 xmlns:vcard="http://www.imc.org/vcard/3.0/"                                                 xmlns:cld="http://www.ukoln.ac.uk/metadata/rslp/1.0/"
                xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
                xmlns:my="http://anyurl/" 
>


<!-- Note: the laborious use of local-name() is required because the ASP script doesn't decorate the XML tree with namespace URI's!!! They use createElement, should use createNode.... Probably easier to compensate here than correct the code... -->

<xsl:output method="html" indent="yes" encoding="iso-8859-1"/>



<xsl:variable name="querystring">rslpsearch.asp?queryandor1=Title&amp;queryfield1=dc%3Atitle&amp;querytype1=LIKE&amp;queryfind1=&amp;queryandor1=AND&amp;queryfield1=dc%3Adescription&amp;querytype1=LIKE&amp;queryfind1=&amp;queryandor1=AND&amp;queryfield1=dc%3Asubject&amp;querytype1=LIKE&amp;queryfind1=&amp;queryandor1=AND</xsl:variable>

  <xsl:template match="/">
    <xsl:element name="html">
      <xsl:element name="head">
        <xsl:element name="link">
          <xsl:attribute name="rel">stylesheet</xsl:attribute>
          <xsl:attribute name="type">text/css</xsl:attribute>
          <xsl:attribute name="href">rslpcld.css</xsl:attribute>
        </xsl:element>      
      </xsl:element>
      <xsl:element name="body">
        <xsl:element name="div">

          <xsl:apply-templates/>

	  </xsl:element>
      </xsl:element>
    </xsl:element>

  </xsl:template>

  <xsl:template match="*[local-name()='RDF']">

    <xsl:element name="h2"><xsl:value-of select="*[local-name()='Collection']/*[local-name()='title']"/></xsl:element>
   
    <xsl:variable name="description" select="."/>

        <xsl:for-each select="document('props.xml')/description/class">
           <xsl:variable name="thisclassname" select="@name"/> 
           <xsl:apply-templates select="$description/*[local-name()=$thisclassname]"/>
        </xsl:for-each>
<!--
        <xsl:apply-templates select="dct:Collection"/>
        <xsl:apply-templates select="cld:Collector"/>
        <xsl:apply-templates select="cld:Owner"/>
        <xsl:apply-templates select="cld:Location"/>
        <xsl:apply-templates select="cld:Adminstrator"/>
--> 

  </xsl:template>

  <xsl:template match="*[local-name()='Collection']">
        
        <xsl:element name="table">
        <xsl:attribute name="class">class</xsl:attribute>
        <xsl:attribute name="width">100%</xsl:attribute>

        <xsl:element name="tr">
        <xsl:element name="td">
        <xsl:attribute name="colspan">2</xsl:attribute>
        <xsl:element name="hr"/>
        <xsl:element name="span">
        <xsl:attribute name="class">classlabel</xsl:attribute>
	  <xsl:apply-templates mode="getlabel" select="."/>
        </xsl:element>
        <xsl:element name="br"/>
        <xsl:element name="hr"/>
        </xsl:element>
        </xsl:element>

       <xsl:variable name="class" select="."/>
       <xsl:variable name="thisclassname" select="local-name()"/>

        <xsl:for-each select="document('props.xml')/description/class[@name=$thisclassname]/property">
           <xsl:variable name="thispropertyname" select="@name"/> 
           <xsl:call-template name="process-property-set">
           <xsl:with-param name="property-set" select="$class/*[local-name()=$thispropertyname]"/>
           <xsl:with-param name="first" select="true()"/>
           </xsl:call-template>
        </xsl:for-each>

    </xsl:element>  	

  </xsl:template>


  <xsl:template match="*[local-name()='Collector']|*[local-name()='Owner']|*[local-name()='Administrator']">
    
        <xsl:element name="table">
        <xsl:attribute name="class">class</xsl:attribute>
        <xsl:attribute name="width">100%</xsl:attribute>

        <xsl:element name="tr">
        <xsl:element name="td">
        <xsl:attribute name="colspan">2</xsl:attribute>
        <xsl:element name="hr"/>
        <xsl:element name="span">
        <xsl:attribute name="class">classlabel</xsl:attribute>
	  <xsl:apply-templates mode="getlabel" select="."/>
        </xsl:element>
        <xsl:element name="br"/>
        <xsl:element name="hr"/>
        </xsl:element>
        </xsl:element>

       <xsl:variable name="class" select="."/>
       <xsl:variable name="thisclassname" select="local-name()"/>

        <xsl:for-each select="document('props.xml')/description/class[@name=$thisclassname]/property">
           <xsl:variable name="thispropertyname" select="@name"/> 
           <xsl:call-template name="process-property-set">
           <xsl:with-param name="property-set" select="$class/*[local-name()=$thispropertyname]"/>
           <xsl:with-param name="first" select="true()"/>
           </xsl:call-template>
        </xsl:for-each>

    </xsl:element>


  </xsl:template>

  
  <xsl:template match="*[local-name()='Location']">

    
        <xsl:element name="table">
        <xsl:attribute name="class">class</xsl:attribute>
        <xsl:attribute name="width">100%</xsl:attribute>

        <xsl:element name="tr">
        <xsl:element name="td">
        <xsl:attribute name="colspan">2</xsl:attribute>
        <xsl:element name="hr"/>
        <xsl:element name="span">
        <xsl:attribute name="class">classlabel</xsl:attribute>
	  <xsl:apply-templates mode="getlabel" select="."/>
        </xsl:element>
        <xsl:element name="br"/>
        <xsl:element name="hr"/>
        </xsl:element>
        </xsl:element>

       <xsl:variable name="class" select="."/>
       <xsl:variable name="thisclassname" select="local-name()"/>

        <xsl:for-each select="document('props.xml')/description/class[@name=$thisclassname]/property">
           <xsl:variable name="thispropertyname" select="@name"/> 
           <xsl:call-template name="process-property-set">
           <xsl:with-param name="property-set" select="$class/*[local-name()=$thispropertyname]"/>
           <xsl:with-param name="first" select="true()"/>
           </xsl:call-template>
        </xsl:for-each>

    
    </xsl:element>

  </xsl:template>


  <xsl:template name="process-property-set">
  <xsl:param name="property-set"/>
  <xsl:param name="first"/>
  
  <xsl:if test="$property-set">

  <xsl:choose>
  <xsl:when test="$first=true()">
          <xsl:element name="tr">
          <xsl:element name="td">
          <xsl:attribute name="class">label</xsl:attribute>
          <xsl:attribute name="width">20%</xsl:attribute>
          <xsl:attribute name="valign">top</xsl:attribute>
          <xsl:element name="span">
          <xsl:attribute name="class">propertylabel</xsl:attribute>

          <xsl:apply-templates mode="getlabel" select="$property-set[position() = 1]"/>

          </xsl:element>
          </xsl:element>

          <xsl:element name="td">
          <xsl:attribute name="class">property</xsl:attribute>
          <xsl:attribute name="width">80%</xsl:attribute>
          <xsl:attribute name="valign">top</xsl:attribute>
          <xsl:element name="span">
          <xsl:attribute name="class">propertyvalue</xsl:attribute>
          <xsl:apply-templates select="$property-set[position()=1]"/>
          </xsl:element>
          <xsl:element name="br"/>
          <xsl:call-template name="process-property-set">
          <xsl:with-param name="property-set" select="$property-set[position() != 1]"/>
          <xsl:with-param name="first" select="false()"/>
          </xsl:call-template>   
          </xsl:element>
          </xsl:element>
  </xsl:when>
  <xsl:otherwise>
          <xsl:element name="span">
          <xsl:attribute name="class">propertyvalue</xsl:attribute>
          <xsl:apply-templates select="$property-set[position()=1]"/>
          </xsl:element>
          <xsl:element name="br"/>
          <xsl:call-template name="process-property-set">
          <xsl:with-param name="property-set" select="$property-set[position() != 1]"/>
          <xsl:with-param name="first" select="false()"/>
          </xsl:call-template>   
  </xsl:otherwise>
  </xsl:choose>
   
  </xsl:if>
  
  </xsl:template>
  
  <xsl:template mode="getlabel" match="*">
    <xsl:choose>
    <xsl:when test="local-name(..)='RDF'">
    <xsl:variable name="myname" select="local-name()"/>
    <xsl:value-of select="document('props.xml')/description/class[@name=$myname]/@label"/>
    </xsl:when>
    <xsl:otherwise> 
    <xsl:variable name="myname" select="local-name()"/>
    <xsl:variable name="myparentname" select="local-name(..)"/>
    <xsl:value-of select="document('props.xml')/description/class[@name=$myparentname]/property[@name =$myname]/@label"/>
    </xsl:otherwise>
    </xsl:choose>  
</xsl:template>

  <xsl:template match="*[local-name()='subject']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dc%3Asubject&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>


  <xsl:template match="*[local-name()='objectName']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=cld%3AobjectName&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>


  <xsl:template match="*[local-name()='agentName']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=cld%3AagentName&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>


  <xsl:template match="*[local-name()='spatial']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dcq%3Aspatial&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>


  <xsl:template match="*[local-name()='temporal']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dcq%3Atemporal&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>


  <xsl:template match="*[local-name()='title']">
      <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='description']">
      <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="*[local-name()='fn']">
    <xsl:apply-templates/>

  </xsl:template>

  <xsl:template match="*[local-name()='org']">
    <xsl:apply-templates/>

  </xsl:template>

  <xsl:template match="*[local-name()='role']">
    <xsl:apply-templates/>

  </xsl:template>

  <xsl:template match="*[local-name()='voice']">
    <xsl:apply-templates/>

  </xsl:template>

  <xsl:template match="*[local-name()='fax']">
    <xsl:apply-templates/>

  </xsl:template>

  <xsl:template match="*[local-name()='email']">
    <xsl:apply-templates/>

  </xsl:template>


  <xsl:template match="*[local-name()='format']">
     <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='language']">
     <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='type']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='identifier']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='creator']">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="*[local-name()='strength']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='accessControl']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='accrualStatus']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='legalStatus']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='custodialHistory']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='note']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='hasLocation']">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="*[local-name()='accessConditions']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='accumulationDateRange']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='contentsDateRange']">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="*[local-name()='hasDescription']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dc%3Atitle&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>

  <xsl:template match="*[local-name()='isDescriptionOf']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dc%3Atitle&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>

  <xsl:template match="*[local-name()='hasAssociation']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='hasPublication']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='isLocationOf']">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="*[local-name()='address']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='postcode']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='country']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='agentHistory']">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*[local-name()='hasPart']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dc%3Atitle&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>

  <xsl:template match="*[local-name()='isPartOf']">

   <xsl:element name="a">
   <xsl:attribute name="href">
      <xsl:value-of select="$querystring"/>
	<xsl:text>&amp;queryfield1=dc%3Atitle&amp;querytype1=%3D&amp;queryfind1=</xsl:text>
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
      <xsl:text>&amp;submit1=Search</xsl:text>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

  </xsl:template>


  <xsl:template match="*[local-name()='seeAlso']">

   <xsl:element name="a">
   <xsl:attribute name="href">
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

   <br/>

  </xsl:template>

  <xsl:template match="*[local-name()='locator']">

   <xsl:element name="a">
   <xsl:attribute name="href">
   	<xsl:value-of select="my:encodeURL(normalize-space(.))"/>
   </xsl:attribute>
 
   <xsl:apply-templates/>
   </xsl:element>

   <br/>

  </xsl:template>

  <msxsl:script language="Javascript" implements-prefix="my">
    function encodeURL(string) {
      if (string.substring(0,5) == "http:")
        {return "http:" + escape(string.substring(5, string.length));}
      else 
        {return escape(string);}
    }
  </msxsl:script>
   
</xsl:stylesheet>